with Ada.Text_IO;
with Ada.Strings.Unbounded; use Ada.Strings.Unbounded;

package body Intervals is

   Quality_Names : constant array(Quality_Interval) of Unbounded_String := (To_unbounded_string("T"),
                                                                            To_unbounded_string("2m"),
                                                                            TO_UNBOUNDED_STRING("2"),
                                                                            To_unbounded_string("3m"),
                                                                            TO_UNBOUNDED_STRING("3M"),
                                                                            To_unbounded_string("4"),
                                                                            To_unbounded_string("5b"),
                                                                            To_unbounded_string("5"),
                                                                            To_unbounded_string("6m"),
                                                                            TO_UNBOUNDED_STRING("6M"),
                                                                            To_unbounded_string("7m"),
                                                                            TO_UNBOUNDED_STRING("7M"));


   function Get_Standard_Small_Name(For_The : Quality_Interval) Return String is
      Result : String := To_String(Quality_Names(For_The));
   begin
      return Result;
   end Get_Standard_Small_Name;

   function Interval_Value(Of_The_quality : Quality_Interval) return Notes_Interval is
      use Ada.Text_IO;
   begin
      Put_Line("Quality_interval " & Quality_Interval'Image(Of_The_Quality) & " : " & Notes_Interval'Image(Quality_Interval'Pos(Of_The_Quality)));
      return Quality_Interval'Pos(Of_The_Quality);
   end Interval_Value;

   function Quality_Of(Interval : Notes_Interval) return Quality_Interval
   is
   begin
      return Quality_Interval'Val(Interval);
   end Quality_Of;

   function Quality_Of(Note : in Notes.Note; To_Tonic : in Notes.Note) return Quality_Interval
   is
      use Notes;
      Diff : Integer;
   begin
      Diff := Notes.Note'Pos(Note) - Notes.Note'Pos(To_tonic);

      if Diff < 0 then
         Diff := Integer(Notes_Interval'Last) + Diff + 1;
      end if;

      return Quality_Interval'Val(diff);
   end Quality_Of;

   function Get_Note(Quality : Quality_Interval; Of_Tonic : Notes.Note) return Notes.Note
   is
      Index : Notes.Note_Index;
      use Notes;
      use Ada.Text_Io;
   begin
      Index := Note_Index(Interval_Value(Quality)) + Note'Pos(Of_Tonic);

      return Notes.Note'Val(Index);
   end Get_Note;

end Intervals;
