with Notes;

package Intervals is

   --Interval in semi-tone between to consecutive plain note
   type Notes_Interval is range 0..(Notes.Note'Pos(Notes.Note'Last) - Notes.Note'Pos(Notes.Note'First));

   -- Intervals as distance from the tonic
   type Quality_Interval is (Tone, Minor_Second, Second, Minor_Third, Major_Third, Perfect_Fourth, Tritone, Perfect_Fifth, Minor_Sixth, Major_Sixth, Minor_Seventh, Major_Seventh);

   -- Name of a interval
   function Get_Standard_Small_Name(For_The : Quality_Interval) Return String;

   -- This function returns the interval from the tonic as number of semi-tones
   function Interval_Value(Of_The_quality : Quality_Interval) return Notes_Interval;

   -- This function returns the interval in semi-tones as quality
   function Quality_Of(Interval : Notes_Interval) return Quality_Interval;

   -- Returns the interval between two notes as a name
   function Quality_Of(Note : Notes.Note; To_Tonic : Notes.Note) return Quality_Interval;

   -- returns the note according to the distance
   function Get_Note(Quality : Quality_Interval; Of_Tonic : Notes.Note) return Notes.Note;

end Intervals;
