with Ada.Strings; use Ada.Strings;

package Notes is
   type Note is (A, A_Sharp, B, C, C_Sharp, D, D_Sharp, E, F, F_Sharp, G, G_Sharp);

   -- Modular type to wrap around the notes and build scales
   -- Warning !!! Modular types start with 0 to modulus-1 which is different from Notes enumeration
   type Note_Index is mod Note'Pos(Note'Last) + 1;

   function Latin_Name(The_Note : Note) return String;
   function International_Name(The_Note : Note) return String;

end Notes;
