with Ada.Text_IO; use Ada.Text_Io;

package body Scales is

   function Get_Scale(Beginning_Note : Notes.Note;Intervals : Interval_Array) return Scale
   is
      Result : Scale(1..Intervals'Length + 1);
      Index : Positive := 1;
      Current_Note_Index : Notes.Note_Index := Notes.Note'Pos(Beginning_Note);

      use type Notes.Note_index;--To make + visible
   begin
      Result(Index) := Notes.Note'Val(Current_Note_Index);
      Index := Index + 1;
      for Interval_index in Intervals'Range loop
         for Tone in 1..Intervals(Interval_index) loop
            Current_Note_Index := Current_Note_Index + 1;
         end loop;
         Result(Index) := Notes.Note'Val(Current_Note_Index);
         Index := Index + 1;
      end loop;

      return Result;
   end Get_Scale;

   function Get_Scale(Beginning_Note : in Notes.Note;Quality_Intervals : in Quality_Interval_Array) return Scale
   is
      Result : Scale(1..Quality_Intervals'Length);
   begin
      for Index in Quality_Intervals'Range loop
	 Result(Index) := Get_Note(Quality_Intervals(Index), Beginning_Note);
      end loop;
      
      return Result;
   end Get_Scale;

   procedure Display (The_Scale:in Scale) is
   begin
      Put_Line("Scale for " & Notes.Latin_Name(The_Scale(1)));
      for Index in The_Scale'Range loop
         Put_Line("Degree " & Positive'Image(Index) & " as "& Get_Standard_Small_Name(Quality_Of(The_Scale(Index), The_Scale(1))) & " : " & Notes.Latin_Name(The_Scale(Index)) & " or " & Notes.International_Name(The_Scale(Index)));
      end loop;
   end Display;
end Scales;
