with Notes;
with Intervals; use Intervals;

package Scales is

   -- The scale object
   type Scale is array(Positive range <>) of Notes.Note;

   -- Array of intervals defining a scale
   type Interval_Array is array(Positive range <>) of Notes_Interval;

   -- Array of Quality interval defining a scale
   type Quality_Interval_Array is array(Positive range <>) of Quality_Interval;

   -- return the scale thanks to the tonic and the list of intervals as semi-tones
   function Get_Scale(Beginning_Note : in Notes.Note;Intervals : in Interval_Array) return Scale;

   -- return the scale thanks to the tonic and the list of intervals as qualities
   function Get_Scale(Beginning_Note : in Notes.Note; Quality_intervals : in Quality_Interval_Array) return Scale;

   procedure Display (The_Scale:in Scale);
end Scales;
